freedombone-app-tox 24KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # Tox Application
  12. #
  13. # License
  14. # =======
  15. #
  16. # Copyright (C) 2014-2016 Bob Mottram <bob@robotics.uk.to>
  17. #
  18. # This program is free software: you can redistribute it and/or modify
  19. # it under the terms of the GNU Affero General Public License as published by
  20. # the Free Software Foundation, either version 3 of the License, or
  21. # (at your option) any later version.
  22. #
  23. # This program is distributed in the hope that it will be useful,
  24. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  25. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  26. # GNU Affero General Public License for more details.
  27. #
  28. # You should have received a copy of the GNU Affero General Public License
  29. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  30. VARIANTS='full full-vim chat'
  31. IN_DEFAULT_INSTALL=0
  32. SHOW_ON_ABOUT=1
  33. TOX_PORT=33445
  34. TOXCORE_REPO="https://github.com/bashrc/toxcore"
  35. TOXCORE_COMMIT='d3fa9f82bda3a8746917502c525237427ba17d45'
  36. TOXID_REPO="https://github.com/bashrc/toxid"
  37. TOX_BOOTSTRAP_ID_FILE=/var/lib/tox-bootstrapd/pubkey.txt
  38. # These are some default nodes, but you can replace them with trusted nodes
  39. # as you prefer. See https://wiki.tox.im/Nodes
  40. TOX_NODES=
  41. #TOX_NODES=(
  42. # '192.254.75.102,2607:5600:284::2,33445,951C88B7E75C867418ACDB5D273821372BB5BD652740BCDF623A4FA293E75D2F,Tox RELENG,US'
  43. # '144.76.60.215,2a01:4f8:191:64d6::1,33445,04119E835DF3E78BACF0F84235B300546AF8B936F035185E2A8E9E0A67C8924F,sonOfRa,DE'
  44. #)
  45. TOXIC_REPO="https://github.com/Tox/toxic"
  46. TOXIC_COMMIT='cf16849b374e484a33a4dffa3dfb937b59d537f2'
  47. TOXIC_FILE=/usr/local/bin/toxic
  48. QTOX_REPO="https://github.com/bashrc/qTox"
  49. QTOX_COMMIT='27a628a3789fca4f31516c3982e580052dd3c773'
  50. tox_variables=(SYSTEM_TYPE
  51. TOXCORE_REPO
  52. TOXCORE_COMMIT
  53. TOXIC_COMMIT
  54. MY_USERNAME
  55. ONION_ONLY
  56. INSTALLED_WITHIN_DOCKER
  57. TOX_PORT
  58. TOX_NODES)
  59. function remove_user_tox {
  60. remove_username="$1"
  61. if [ -d /home/$remove_username/.config/tox ]; then
  62. if [ -d /home/$remove_username/.config/tox/chatlogs ]; then
  63. shred -zu /home/$remove_username/.config/tox/chatlogs/*
  64. rm -rf /home/$remove_username/.config/tox/chatlogs
  65. fi
  66. shred -zu /home/$remove_username/.config/tox/*
  67. fi
  68. }
  69. function add_user_tox {
  70. new_username="$1"
  71. # Note: password isn't used
  72. new_user_password="$2"
  73. USER_TOX_FILE=/home/${new_username}/.config/tox/data.tox
  74. if [ ! -f $USER_TOX_FILE ]; then
  75. mkdir -p /home/${new_username}/.config/tox
  76. chown -R ${new_username}:${new_username} /home/${new_username}/.config
  77. su -c "toxid -u ${new_username} -n data" - $new_username
  78. su -c "toxid --setuser ${new_username}" - $new_username
  79. fi
  80. }
  81. function run_client_tox {
  82. # create a tox user
  83. USER_TOX_FILE=/home/${USER}/.config/tox/data.tox
  84. if [ ! -f $USER_TOX_FILE ]; then
  85. mkdir -p /home/${USER}/.config/tox
  86. chown -R ${USER}:${USER} /home/${USER}/.config
  87. toxid -u ${USER} -n data
  88. toxid --setuser ${USER}
  89. fi
  90. toxic -f $USER_TOX_FILE --force-tcp --SOCKS5-proxy 127.0.0.1 9050
  91. }
  92. function install_interactive_tox {
  93. echo -n ''
  94. APP_INSTALLED=1
  95. }
  96. function change_password_tox {
  97. echo -n ''
  98. }
  99. function mesh_tox_qtox {
  100. if [ ! ${rootdir}$INSTALL_DIR ]; then
  101. INSTALL_DIR=${rootdir}/root/build
  102. fi
  103. if [ ! -d ${rootdir}$INSTALL_DIR ]; then
  104. mkdir -p ${rootdir}$INSTALL_DIR
  105. fi
  106. chroot "${rootdir}" apt-get -y install build-essential libatk1.0-0 libbz2-1.0 libc6 libcairo2 libdbus-1-3 libegl1-mesa libfontconfig1 libfreetype6 libgcc1 libgdk-pixbuf2.0-0 libgl1-mesa-glx libglib2.0-0 libgtk2.0-0 libice6 libicu52 libjpeg62-turbo libmng1 libmtdev1 libopenal1 libopus0 libpango-1.0-0 libpangocairo-1.0-0 libpangoft2-1.0-0 libpng12-0 libqrencode3 libsm6 libsodium13 libsqlite3-0 libssl1.0.0 libstdc++6 libtiff5 libudev1 libvpx1 libwayland-client0 libwayland-cursor0 libwayland-egl1-mesa libwebp5 libx11-6 libx11-xcb1 libxcb-glx0 libxcb-icccm4 libxcb-image0 libxcb-keysyms1 libxcb-randr0 libxcb-render-util0 libxcb-render0 libxcb-shape0 libxcb-shm0 libxcb-sync1 libxcb-xfixes0 libxcb-xinerama0 libxcb1 libxext6 libxfixes3 libxi6 libxrender1 libxss1 zlib1g libopus-dev libvpx-dev
  107. chroot "${rootdir}" apt-get -y install build-essential qt5-qmake qt5-default qttools5-dev-tools libqt5opengl5-dev libqt5svg5-dev libopenal-dev libxss-dev qrencode libqrencode-dev libglib2.0-dev libgdk-pixbuf2.0-dev libgtk2.0-dev libsqlcipher-dev libopus-dev libvpx-dev libavformat-dev libavdevice-dev libswscale-dev libavutil-dev libavcodec-dev libavcodec56 libavcodec57 libavfilter-dev libavfilter6
  108. mesh_install_ffmpeg
  109. git clone $QTOX_REPO ${rootdir}$INSTALL_DIR/qtox
  110. if [ ! -d ${rootdir}$INSTALL_DIR/qtox ]; then
  111. exit 72428
  112. fi
  113. cd ${rootdir}${INSTALL_DIR}/qtox
  114. git checkout $QTOX_COMMIT -b $QTOX_COMMIT
  115. chroot ${rootdir} /bin/bash -x <<EOF
  116. cd ${INSTALL_DIR}/qtox
  117. qmake
  118. make
  119. make install
  120. EOF
  121. if [ ! -f ${rootdir}/usr/bin/qtox ]; then
  122. exit 75784
  123. fi
  124. }
  125. function reconfigure_tox {
  126. echo -n ''
  127. }
  128. function upgrade_tox {
  129. function_check set_repo_commit
  130. set_repo_commit $INSTALL_DIR/toxcore "toxcore commit" "$TOXCORE_COMMIT" $TOXCORE_REPO
  131. if [[ $(commit_has_changed $INSTALL_DIR/toxcore "toxcore commit" "$TOXCORE_COMMIT") == "1" ]]; then
  132. cd $INSTALL_DIR/toxcore
  133. sed -i 's|ExecStart=.*|ExecStart=/usr/local/bin/tox-bootstrapd --config /etc/tox-bootstrapd.conf|g' $rootdir/etc/systemd/system/tox-bootstrapd.service
  134. autoreconf -i
  135. ./configure --enable-daemon
  136. make
  137. make install
  138. systemctl daemon-reload
  139. systemctl restart tox-bootstrapd.service
  140. fi
  141. function_check set_repo_commit
  142. set_repo_commit $INSTALL_DIR/toxic "Toxic commit" "$TOXIC_COMMIT" $TOXIC_REPO
  143. if [[ $(commit_has_changed $INSTALL_DIR/toxic "Toxic commit" "$TOXIC_COMMIT") == "1" ]]; then
  144. cd $INSTALL_DIR/toxic
  145. make
  146. make install
  147. fi
  148. }
  149. function backup_local_tox {
  150. if [ -d /var/lib/tox-bootstrapd ]; then
  151. echo $"Backing up Tox"
  152. if [ -d /var/lib/tox-bootstrapd ]; then
  153. cp /etc/tox-bootstrapd.conf /var/lib/tox-bootstrapd
  154. if [ -d /var/lib/tox-bootstrapd/Maildir ]; then
  155. rm -rf /var/lib/tox-bootstrapd/Maildir
  156. fi
  157. fi
  158. function_check backup_directory_to_usb
  159. backup_directory_to_usb /var/lib/tox-bootstrapd tox
  160. echo $"Backup of Tox complete"
  161. fi
  162. }
  163. function restore_local_tox {
  164. if [ -d $USB_MOUNT/backup/tox ]; then
  165. echo $"Restoring Tox node settings"
  166. function_check restore_directory_from_usb
  167. restore_directory_from_usb / tox
  168. if [ ! "$?" = "0" ]; then
  169. function_check set_user_permissions
  170. set_user_permissions
  171. function_check backup_unmount_drive
  172. backup_unmount_drive
  173. exit 6393
  174. fi
  175. cp /var/lib/tox-bootstrapd/tox-bootstrapd.conf /etc/tox-bootstrapd.conf
  176. systemctl restart tox-bootstrapd.service
  177. if [ ! "$?" = "0" ]; then
  178. systemctl status tox-bootstrapd.service
  179. function_check set_user_permissions
  180. set_user_permissions
  181. function_check backup_unmount_drive
  182. backup_unmount_drive
  183. exit 59369
  184. fi
  185. fi
  186. }
  187. function backup_remote_tox {
  188. if [ -d /var/lib/tox-bootstrapd ]; then
  189. echo "Backing up Tox node settings"
  190. if [ -d /var/lib/tox-bootstrapd/Maildir ]; then
  191. rm -rf /var/lib/tox-bootstrapd/Maildir
  192. fi
  193. cp /etc/tox-bootstrapd.conf /var/lib/tox-bootstrapd
  194. backup_directory_to_friend /var/lib/tox-bootstrapd tox
  195. echo "Backup of Tox node settings complete"
  196. fi
  197. }
  198. function restore_remote_tox {
  199. if [ -d $SERVER_DIRECTORY/backup/tox ]; then
  200. echo $"Restoring Tox node settings"
  201. function_check restore_directory_from_friend
  202. restore_directory_from_friend / tox
  203. if [ ! "$?" = "0" ]; then
  204. exit 93653
  205. fi
  206. cp /var/lib/tox-bootstrapd/tox-bootstrapd.conf /etc/tox-bootstrapd.conf
  207. systemctl restart tox-bootstrapd.service
  208. if [ ! "$?" = "0" ]; then
  209. systemctl status tox-bootstrapd.service
  210. exit 59369
  211. fi
  212. echo $"Restore of Tox node complete"
  213. fi
  214. }
  215. function remove_tox_node {
  216. iptables -D INPUT -p tcp --dport $TOX_PORT -j ACCEPT
  217. iptables -D INPUT -p udp --dport $TOX_PORT -j ACCEPT
  218. function_check save_firewall_settings
  219. save_firewall_settings
  220. function_check remove_onion_service
  221. remove_onion_service tox ${TOX_PORT}
  222. ${PROJECT_NAME}-mesh-install -f tox_node --remove yes
  223. if [ ! "$?" = "0" ]; then
  224. echo $'Failed to remove tox node'
  225. exit 763836
  226. fi
  227. remove_completion_param install_tox_node
  228. remove_completion_param configure_firewall_for_tox
  229. }
  230. function remove_tox_avahi {
  231. cd $INSTALL_DIR/toxid
  232. make uninstall
  233. rm -rf $INSTALL_DIR/toxid
  234. sed -i '/tox_avahi/d' $COMPLETION_FILE
  235. }
  236. function remove_tox_client {
  237. ${PROJECT_NAME}-mesh-install -f tox_client --remove yes
  238. if [ ! "$?" = "0" ]; then
  239. echo $'Could not remove Tox client'
  240. exit 737253
  241. fi
  242. sed -i '/install_tox_client/d' $COMPLETION_FILE
  243. sed -i '/Tox /d' $COMPLETION_FILE
  244. sed -i '/Toxic /d' $COMPLETION_FILE
  245. }
  246. function remove_tox {
  247. remove_tox_client
  248. remove_tox_avahi
  249. remove_tox_node
  250. }
  251. function configure_firewall_for_tox {
  252. if [ ! $INSTALLING_MESH ]; then
  253. if [[ $(is_completed $FUNCNAME) == "1" ]]; then
  254. return
  255. fi
  256. fi
  257. if [[ $INSTALLED_WITHIN_DOCKER == "yes" ]]; then
  258. # docker does its own firewalling
  259. return
  260. fi
  261. if [[ $ONION_ONLY != "no" ]]; then
  262. return
  263. fi
  264. TOX_PORT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOX_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  265. if [ ${#TOX_PORT_MAIN} -gt 2 ]; then
  266. TOX_PORT=$TOX_PORT_MAIN
  267. fi
  268. if [ ! $TOX_PORT ]; then
  269. echo $'No Tox port was specified'
  270. exit 32856
  271. fi
  272. iptables -A INPUT -p tcp --dport $TOX_PORT -j ACCEPT
  273. iptables -A INPUT -p udp --dport $TOX_PORT -j ACCEPT
  274. function_check save_firewall_settings
  275. save_firewall_settings
  276. OPEN_PORTS+=("Tox $TOX_PORT")
  277. mark_completed $FUNCNAME
  278. }
  279. function tox_avahi {
  280. if [[ $(is_completed $FUNCNAME) == "1" ]]; then
  281. return
  282. fi
  283. if [ ! -d /etc/avahi ]; then
  284. echo $'tox_avahi: avahi is not installed'
  285. exit 87359
  286. fi
  287. # install a command to obtain the Tox ID
  288. cd $INSTALL_DIR
  289. function_check git_clone
  290. git_clone $TOXID_REPO $INSTALL_DIR/toxid
  291. if [ ! -d $INSTALL_DIR/toxid ]; then
  292. exit 63921
  293. fi
  294. cd $INSTALL_DIR/toxid
  295. make
  296. if [ ! "$?" = "0" ]; then
  297. exit 58432
  298. fi
  299. make install
  300. if [[ $SYSTEM_TYPE == "mesh"* ]]; then
  301. toxavahi
  302. # publish regularly
  303. function_check cron_add_mins
  304. cron_add_mins 1 'toxavahi 2> /dev/null'
  305. fi
  306. systemctl restart avahi-daemon
  307. mark_completed $FUNCNAME
  308. }
  309. function install_tox_node {
  310. if [[ $(app_is_installed tox_node) == "1" ]]; then
  311. return
  312. fi
  313. function_check mesh_tox_node
  314. mesh_tox_node
  315. # onion address for bootstrapping
  316. TOX_ONION_HOSTNAME=$(add_onion_service tox ${TOX_PORT} ${TOX_PORT})
  317. systemctl restart tox-bootstrapd.service
  318. sleep 3
  319. TOX_PUBLIC_KEY=$(cat /var/log/syslog | grep tox | grep "Public Key" | tail -n 1 | awk -F ' ' '{print $8}')
  320. if [ ${#TOX_PUBLIC_KEY} -lt 30 ]; then
  321. echo $'Could not obtain the tox node public key'
  322. exit 6529
  323. fi
  324. # save the public key for later reference
  325. echo "$TOX_PUBLIC_KEY" > $TOX_BOOTSTRAP_ID_FILE
  326. function_check configure_firewall_for_tox
  327. configure_firewall_for_tox
  328. if ! grep -q $"Your Tox node public key is" /home/$MY_USERNAME/README; then
  329. echo '' >> /home/$MY_USERNAME/README
  330. echo '' >> /home/$MY_USERNAME/README
  331. echo 'Tox' >> /home/$MY_USERNAME/README
  332. echo '===' >> /home/$MY_USERNAME/README
  333. echo $"tox onion domain: ${TOX_ONION_HOSTNAME}" >> /home/$MY_USERNAME/README
  334. echo $"Your Tox node public key is: $TOX_PUBLIC_KEY" >> /home/$MY_USERNAME/README
  335. echo $'In the Toxic client you can connect to it with:' >> /home/$MY_USERNAME/README
  336. echo " /connect $DEFAULT_DOMAIN_NAME.local $TOX_PORT $TOX_PUBLIC_KEY" >> /home/$MY_USERNAME/README
  337. chown $MY_USERNAME:$MY_USERNAME /home/$MY_USERNAME/README
  338. chmod 600 /home/$MY_USERNAME/README
  339. fi
  340. function_check configure_firewall_for_tox
  341. configure_firewall_for_tox
  342. install_completed tox_node
  343. }
  344. function install_tox_client {
  345. if [[ $(app_is_installed tox_client) == "1" ]]; then
  346. return
  347. fi
  348. function_check mesh_tox_client
  349. mesh_tox_client
  350. install_completed tox_client
  351. }
  352. function mesh_tox_node {
  353. # obtain commits from the main file
  354. TOXCORE_COMMIT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXCORE_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  355. if [ ${#TOXCORE_COMMIT_MAIN} -gt 10 ]; then
  356. TOXCORE_COMMIT=$TOXCORE_COMMIT_MAIN
  357. fi
  358. if [ ! $TOXCORE_COMMIT ]; then
  359. echo $'No Tox commit was specified'
  360. exit 76325
  361. fi
  362. TOXID_REPO_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXID_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  363. if [ ${#TOXID_REPO_MAIN} -gt 5 ]; then
  364. TOXID_REPO=$TOXID_REPO_MAIN
  365. fi
  366. if [ ! $TOXID_REPO ]; then
  367. echo $'No ToxID repo was specified'
  368. exit 78252
  369. fi
  370. TOX_PORT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOX_PORT=" | head -n 1 | awk -F '=' '{print $2}')
  371. if [ ${#TOX_PORT_MAIN} -gt 2 ]; then
  372. TOX_PORT=$TOX_PORT_MAIN
  373. fi
  374. if [ ! $TOX_PORT ]; then
  375. echo $'No Tox port was specified'
  376. exit 32856
  377. fi
  378. TOXCORE_REPO_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXCORE_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  379. if [ ${#TOXCORE_REPO_MAIN} -gt 10 ]; then
  380. TOXCORE_REPO=$TOXCORE_REPO_MAIN
  381. fi
  382. if [ ! $TOXCORE_REPO ]; then
  383. echo $'No Tox repo was specified'
  384. exit 16865
  385. fi
  386. if [ ! $TOXCORE_COMMIT ]; then
  387. echo $'No Tox commit was specified'
  388. exit 76325
  389. fi
  390. if [ ! $TOXCORE_REPO ]; then
  391. echo $'No Tox repo was specified'
  392. exit 16865
  393. fi
  394. if [ $rootdir ]; then
  395. chroot ${rootdir} apt-get -y install build-essential libtool autotools-dev
  396. chroot ${rootdir} apt-get -y install automake checkinstall check git yasm
  397. chroot ${rootdir} apt-get -y install libsodium13 libsodium-dev libcap2-bin
  398. chroot ${rootdir} apt-get -y install libconfig9 libconfig-dev autoconf
  399. chroot ${rootdir} apt-get -y install libopus-dev libvpx-dev
  400. else
  401. apt-get -y install build-essential libtool autotools-dev
  402. apt-get -y install automake checkinstall check git yasm
  403. apt-get -y install libsodium13 libsodium-dev libcap2-bin
  404. apt-get -y install libconfig9 libconfig-dev autoconf
  405. apt-get -y install libopus-dev libvpx-dev
  406. fi
  407. if [ ! -d ${rootdir}${INSTALL_DIR} ]; then
  408. mkdir -p ${rootdir}${INSTALL_DIR}
  409. fi
  410. if [ ! -d ${rootdir}${INSTALL_DIR}/toxcore ]; then
  411. git clone ${TOXCORE_REPO} ${rootdir}${INSTALL_DIR}/toxcore
  412. if [ ! "$?" = "0" ]; then
  413. exit 429252
  414. fi
  415. fi
  416. cd ${rootdir}$INSTALL_DIR/toxcore
  417. git checkout $TOXCORE_COMMIT -b $TOXCORE_COMMIT
  418. if [ ${rootdir} ]; then
  419. chroot ${rootdir} /bin/bash -x <<EOF
  420. cd ${INSTALL_DIR}/toxcore
  421. autoreconf -i
  422. ./configure --enable-daemon
  423. make
  424. make install
  425. EOF
  426. else
  427. /bin/bash -x <<EOF
  428. cd ${INSTALL_DIR}/toxcore
  429. autoreconf -i
  430. ./configure --enable-daemon
  431. make
  432. make install
  433. EOF
  434. fi
  435. cp $rootdir/usr/local/lib/libtoxcore* $rootdir/usr/lib/
  436. cp ${rootdir}${INSTALL_DIR}/toxcore/other/bootstrap_daemon/tox-bootstrapd.service $rootdir/etc/systemd/system/
  437. sed -i 's|ExecStart=.*|ExecStart=/usr/local/bin/tox-bootstrapd --config /etc/tox-bootstrapd.conf|g' $rootdir/etc/systemd/system/tox-bootstrapd.service
  438. if [ ${rootdir} ]; then
  439. chroot ${rootdir} systemctl enable tox-bootstrapd.service
  440. else
  441. systemctl enable tox-bootstrapd.service
  442. fi
  443. SECONDS=0
  444. if [ ! -f $rootdir/usr/local/bin/tox-bootstrapd ]; then
  445. duration=$SECONDS
  446. echo $"Toxcore compile failed at $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  447. echo $'Unable to make toxcore'
  448. exit 73835
  449. fi
  450. duration=$SECONDS
  451. echo $"Toxcore compile $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  452. if [ ${rootdir} ]; then
  453. chroot ${rootdir} /usr/sbin/useradd --home-dir /var/lib/tox-bootstrapd --create-home --system --shell /sbin/nologin --comment $"Account to run Tox's DHT bootstrap daemon" --user-group tox-bootstrapd
  454. chroot ${rootdir} /bin/chmod 700 /var/lib/tox-bootstrapd
  455. else
  456. useradd --home-dir /var/lib/tox-bootstrapd --create-home --system --shell /sbin/nologin --comment $"Account to run Tox's DHT bootstrap daemon" --user-group tox-bootstrapd
  457. chmod 700 /var/lib/tox-bootstrapd
  458. fi
  459. # remove Maildir
  460. if [ -d $rootdir/var/lib/tox-bootstrapd/Maildir ]; then
  461. rm -rf $rootdir/var/lib/tox-bootstrapd/Maildir
  462. fi
  463. # create configuration file
  464. TOX_BOOTSTRAP_CONFIG=$rootdir/etc/tox-bootstrapd.conf
  465. echo "port = $TOX_PORT" > $TOX_BOOTSTRAP_CONFIG
  466. echo 'keys_file_path = "/var/lib/tox-bootstrapd/keys"' >> $TOX_BOOTSTRAP_CONFIG
  467. echo 'pid_file_path = "/var/run/tox-bootstrapd/tox-bootstrapd.pid"' >> $TOX_BOOTSTRAP_CONFIG
  468. echo 'enable_ipv6 = true' >> $TOX_BOOTSTRAP_CONFIG
  469. echo 'enable_ipv4_fallback = true' >> $TOX_BOOTSTRAP_CONFIG
  470. echo 'enable_lan_discovery = true' >> $TOX_BOOTSTRAP_CONFIG
  471. echo 'enable_tcp_relay = true' >> $TOX_BOOTSTRAP_CONFIG
  472. echo "tcp_relay_ports = [443, 3389, $TOX_PORT]" >> $TOX_BOOTSTRAP_CONFIG
  473. echo 'enable_motd = true' >> $TOX_BOOTSTRAP_CONFIG
  474. echo 'motd = "tox-bootstrapd"' >> $TOX_BOOTSTRAP_CONFIG
  475. if [ $TOX_NODES ]; then
  476. echo 'bootstrap_nodes = (' >> $TOX_BOOTSTRAP_CONFIG
  477. toxcount=0
  478. while [ "x${TOX_NODES[toxcount]}" != "x" ]
  479. do
  480. toxval_ipv4=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $1}')
  481. toxval_ipv6=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $2}')
  482. toxval_port=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $3}')
  483. toxval_pubkey=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $4}')
  484. toxval_maintainer=$(echo $TOX_NODES[toxcount] | awk -F ',' '{print $5}')
  485. echo "{ // $toxval_maintainer" >> $TOX_BOOTSTRAP_CONFIG
  486. if [[ $toxval_ipv6 != 'NONE' ]]; then
  487. echo " address = \"$toxval_ipv6\"" >> $TOX_BOOTSTRAP_CONFIG
  488. else
  489. echo " address = \"$toxval_ipv4\"" >> $TOX_BOOTSTRAP_CONFIG
  490. fi
  491. echo " port = $toxval_port" >> $TOX_BOOTSTRAP_CONFIG
  492. echo " public_key = \"$toxval_pubkey\"" >> $TOX_BOOTSTRAP_CONFIG
  493. toxcount=$(( $toxcount + 1 ))
  494. if [ "x${TOX_NODES[toxcount]}" != "x" ]; then
  495. echo "}," >> $TOX_BOOTSTRAP_CONFIG
  496. else
  497. echo "}" >> $TOX_BOOTSTRAP_CONFIG
  498. fi
  499. done
  500. echo ')' >> $TOX_BOOTSTRAP_CONFIG
  501. fi
  502. }
  503. function mesh_tox_avahi {
  504. if [ ! -d $rootdir/etc/avahi ]; then
  505. echo $'tox_avahi: avahi is not installed'
  506. exit 87359
  507. fi
  508. if [ ! $TOXID_REPO ]; then
  509. echo $'No ToxID repo was specified'
  510. exit 78252
  511. fi
  512. if [ ! -d ${rootdir}${INSTALL_DIR} ]; then
  513. mkdir -p ${rootdir}${INSTALL_DIR}
  514. fi
  515. git clone ${TOXID_REPO} ${rootdir}${INSTALL_DIR}/toxid
  516. if [ ! -d ${rootdir}${INSTALL_DIR}/toxid ]; then
  517. echo $'Unable to clone toxid repo'
  518. exit 768352
  519. fi
  520. if [ ${rootdir} ]; then
  521. chroot ${rootdir} /bin/bash -x <<EOF
  522. cd ${INSTALL_DIR}/toxid
  523. make
  524. make install
  525. EOF
  526. else
  527. /bin/bash -x <<EOF
  528. cd ${INSTALL_DIR}/toxid
  529. make
  530. make install
  531. EOF
  532. fi
  533. if [ ! -f $rootdir/usr/local/bin/toxid ]; then
  534. echo $'toxid not found'
  535. exit 74370
  536. fi
  537. if [ ! -f $rootdir/usr/local/bin/toxavahi ]; then
  538. exit 3621729
  539. fi
  540. MESH_SYNC_COMMAND=$rootdir/usr/bin/mesh-sync
  541. echo '#!/bin/bash' > $MESH_SYNC_COMMAND
  542. echo '/usr/local/bin/toxavahi 2> /dev/null' >> $MESH_SYNC_COMMAND
  543. echo '/usr/local/bin/meshavahi 2> /dev/null' >> $MESH_SYNC_COMMAND
  544. chmod +x $MESH_SYNC_COMMAND
  545. if ! grep -q "mesh-sync" ${rootdir}/etc/crontab; then
  546. echo "*/1 * * * * root /usr/bin/mesh-sync 2> /dev/null" >> ${rootdir}/etc/crontab
  547. echo "*/1 * * * * root ( sleep 20 ; /usr/bin/mesh-sync 2> /dev/null )" >> ${rootdir}/etc/cro echo "*/1 * * * * root ( sleep 40 ; /usr/bin/mesh-sync 2> /dev/null )" >> ${rootdir}/etc/crontab
  548. fi
  549. }
  550. function mesh_tox_client {
  551. TOXIC_FILE=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  552. # obtain commits from the main file
  553. TOXIC_COMMIT_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_COMMIT=" | head -n 1 | awk -F "'" '{print $2}')
  554. if [ ${#TOXIC_COMMIT_MAIN} -gt 10 ]; then
  555. TOXIC_COMMIT=$TOXIC_COMMIT_MAIN
  556. fi
  557. TOXIC_REPO_MAIN=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_REPO=" | head -n 1 | awk -F '"' '{print $2}')
  558. if [ ${#TOXIC_REPO_MAIN} -gt 5 ]; then
  559. TOXIC_REPO=$TOXIC_REPO_MAIN
  560. fi
  561. if [ ${rootdir} ]; then
  562. chroot ${rootdir} apt-get -y install libncursesw5-dev libconfig-dev libqrencode-dev
  563. chroot ${rootdir} apt-get -y install libcurl4-openssl-dev libvpx-dev libopenal-dev
  564. else
  565. apt-get -y install libncursesw5-dev libconfig-dev libqrencode-dev
  566. apt-get -y install libcurl4-openssl-dev libvpx-dev libopenal-dev
  567. fi
  568. TEMP_SCRIPT_NAME=fbtmp728353.sh
  569. TEMP_SCRIPT=/tmp/$TEMP_SCRIPT_NAME
  570. echo '#!/bin/bash' > $TEMP_SCRIPT
  571. echo "mkdir -p $INSTALL_DIR" >> $TEMP_SCRIPT
  572. echo "git clone $TOXIC_REPO $INSTALL_DIR/toxic" >> $TEMP_SCRIPT
  573. echo "cd $INSTALL_DIR/toxic" >> $TEMP_SCRIPT
  574. echo "git checkout $TOXIC_COMMIT -b $TOXIC_COMMIT" >> $TEMP_SCRIPT
  575. echo 'make' >> $TEMP_SCRIPT
  576. echo 'if [ ! "$?" = "0" ]; then' >> $TEMP_SCRIPT
  577. echo ' exit 1' >> $TEMP_SCRIPT
  578. echo 'fi' >> $TEMP_SCRIPT
  579. echo 'make install' >> $TEMP_SCRIPT
  580. echo 'exit 0' >> $TEMP_SCRIPT
  581. chmod +x $TEMP_SCRIPT
  582. cp $TEMP_SCRIPT $rootdir/root/
  583. TOXIC_FILE=$(cat /usr/share/${PROJECT_NAME}/apps/${PROJECT_NAME}-app-tox | grep "TOXIC_FILE=" | head -n 1 | awk -F '=' '{print $2}')
  584. SECONDS=0
  585. if [ ${rootdir} ]; then
  586. chroot ${rootdir} /root/$TEMP_SCRIPT_NAME
  587. else
  588. /root/$TEMP_SCRIPT_NAME
  589. fi
  590. if [ ! "$?" = "0" ]; then
  591. duration=$SECONDS
  592. echo $"Toxic client compile failed at $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  593. echo $'Unable to make tox client'
  594. rm $TEMP_SCRIPT
  595. exit 74872
  596. fi
  597. rm $TEMP_SCRIPT
  598. if [ ! -f $rootdir$TOXIC_FILE ]; then
  599. echo $"Tox client was not installed to $TOXIC_FILE"
  600. exit 63278
  601. fi
  602. duration=$SECONDS
  603. echo $"Toxic client compile $(($duration / 60)) minutes and $(($duration % 60)) seconds elapsed."
  604. }
  605. function enable_tox_repo {
  606. echo 'deb http://download.opensuse.org/repositories/home:/antonbatenev:/tox/Debian_8.0/ /' > $rootdir/etc/apt/sources.list.d/tox.list
  607. chroot "$rootdir" /usr/bin/wget -q http://download.opensuse.org/repositories/home:antonbatenev:tox/Debian_8.0/Release.key -O- | apt-key add -
  608. chroot "$rootdir" apt-get update
  609. echo "Tox Repository Installed."
  610. }
  611. function install_tox {
  612. configure_firewall_for_tox
  613. if [ $INSTALLING_MESH ]; then
  614. mesh_tox_node
  615. mesh_tox_avahi
  616. mesh_tox_client
  617. else
  618. install_tox_node
  619. tox_avahi
  620. install_tox_client
  621. fi
  622. APP_INSTALLED=1
  623. }
  624. # NOTE: deliberately no exit 0